/*******************************************************
*   Scooter©
*
*   Scooter config panel. Nice and modular.
*
*   @author  TheAbstractCompany, YNOP(ynop@acm.org) 
*   @vertion 1.0
*   @date    November 3 1999
*******************************************************/
#include <StringView.h>

#include "MySSConfigPanel.h"
#include "Scoot.h"

rgb_color DefaultGray = { 216,216,216,255 };

/*******************************************************
*   Config panel. Not much space so use it wisely
*******************************************************/
MySSConfigPanel::MySSConfigPanel(BRect frame, Scoot *Ssaver)
	: BView(frame, "", B_FOLLOW_NONE, B_WILL_DRAW),
	  saver(Ssaver)
{

   BRect bounds = Bounds();
   bounds.InsetBy(5,0);
		
   font_height fh;
   be_plain_font->GetHeight(&fh);
   bounds.bottom = (fh.ascent + fh.descent) * 4 + 10; // fontHight * num of lines + somespace
   BRect textRect = bounds;
   		
   BTextView *textView = new BTextView(bounds, "stringView",textRect, B_FOLLOW_NONE);
   textView->SetText("Scooter! by YNOP (ynop@acm.org)\n\nBased on Scoot! by Seth Flaxman\nhttp://www.benews.com/story/2319.1.html");
   textView->MakeEditable(false);
   textView->MakeSelectable(false);
   textView->SetViewColor(DefaultGray);
   AddChild(textView);
   
   bounds.OffsetTo(bounds.left, bounds.bottom + 5);
   fTextControl = new BTextControl(bounds, "fTextControl", "Image file:", "", new BMessage('path'));
   AddChild(fTextControl);

   fTextControl->SetDivider(fTextControl->StringWidth("Image file:") + 5);

   if(saver->fPath != MyPath){ fTextControl->SetText(saver->fPath.Path()); MyPath = saver->fPath; }
}

/*******************************************************
*  When we attach the config panel to the window lets
*  set the target of any contorls we have to "this" 
*  so that we can get the messages. Also set some 
*  niffty flags.
*******************************************************/
void MySSConfigPanel::AttachedToWindow(void){
   rgb_color view_color(Parent()->ViewColor());
   SetViewColor(view_color);
   
   fTextControl->SetViewColor(view_color);
   fTextControl->SetTarget(this);
  
  
   window_flags = Window()->Flags();
   Window()->SetFlags(window_flags | B_ASYNCHRONOUS_CONTROLS);
}

/*******************************************************
*  Undo anything we migh have dont to the window, and
*  do any cleanup or anything else that might effect 
*  not haveing a parent.  
*******************************************************/
void MySSConfigPanel::DetachedFromWindow(void){
   Window()->SetFlags(window_flags);
}

/*******************************************************
*  This is 
*******************************************************/
void MySSConfigPanel::UpdatePrefs(void){
//   if(saver->fPath != MyPath){ fTextControl->SetText(saver->fPath.Path()); MyPath = saver->fPath; }
}

/*******************************************************
*
*******************************************************/
void MySSConfigPanel::MessageReceived(BMessage *msg){
   switch (msg->what) {
      case 'path':
         saver->Lock();
         saver->fPath.SetTo(fTextControl->Text());
         MyPath.SetTo(fTextControl->Text());
         saver->ReadBitmap(saver->fPath.Path());
         saver->Unlock();
         break;
      default:
         BView::MessageReceived(msg);
         break;
   }
}

