/*******************************************************
*   Scooter©
*
*   Scoot is a screensaver wirten by Seth Flaxman a 
*   a BeNews Editor (www.benews.com). He did a great
*   job and all, but there is a phosify among Be 
*   developers, well at least me, that stuff should
*   live update, You check a box it should take effect,
*   not latter .. not after you hit "apply" but NOW.
*   so I added some stuff that made it a little more
*   live. It also make the comfig panel more modular.
*   This might not be the best way to do things but hey
*
*   We also fixxed some Major problems with the limit
*   of the number of lines you could have. Seth limited
*   you to 25 lines. thats fine if you have a images 
*   is greater then 32 pixels hight on a 800x600 screen
*   but if you are running at 1024 or > then it would
*   have somerealy be effects. The arrays are all
*   dynamic now so they should do any number of rows   
*
*   @author  TheAbstractCompany, YNOP(ynop@acm.org) 
*   @vertion 1.0
*   @date    November 3 1999
*******************************************************/
#include <String.h>

#include "Scoot.h"
#include "MySSConfigPanel.h"

/*******************************************************
*   Hook for screensaver. All screensaver must have.
*   So just return our class and get on with the fun
*******************************************************/
BScreenSaver *instantiate_screen_saver(BMessage *msg, image_id image){
	return new Scoot(msg, image);
}

/*******************************************************
*   Creat our class and resotor all saved messages and
*   state
*******************************************************/
Scoot::Scoot(BMessage *msg, image_id image):BScreenSaver(msg, image),BLocker("Scooter_lock"){
   fBitmap = NULL;
	
   if (!msg->IsEmpty()){
      restore_state(msg);
   }
}

/*******************************************************
*   Clean up after our sloppy bitmap.
*******************************************************/
Scoot::~Scoot(){
   delete fBitmap;
}

/*******************************************************
*   Uh. do we ever fail. I gess not. So confident in ourselfs
*******************************************************/
status_t Scoot::InitCheck(){
   return B_OK;
}

/*******************************************************
*   Make a fake bitmap if we have none. Defenalty sould
*   say someplace "No bitmap" so the use knows.
*******************************************************/
void Scoot::MakeBitmap(){
   // make a bitmap
   BRect r(0,0,100,50);
   fBitmap = new BBitmap(r, B_CMAP8, true);
   BView *v = new BView(r, "view", B_FOLLOW_ALL, B_WILL_DRAW);
   fBitmap->Lock();
   fBitmap->AddChild(v);
   v->MovePenTo(5,25);
   v->SetHighColor(255,0,0);
   v->SetLowColor(255,0,0);
   v->FillRect(r);
   v->SetHighColor(255,255,255);
   v->DrawString("No bitmap set!");
   v->Sync();
   fBitmap->RemoveChild(v);
   delete v;
   fBitmap->Unlock();
		
   fHeight = fBitmap->Bounds().Height() + 1;
   fWidth = fBitmap->Bounds().Width();
}

/*******************************************************
*   Start up the saver, do things for setup right befor
*   we start drawing. Also we can tell if we are in 
*   preview mode here, so save that off.
*******************************************************/
status_t Scoot::StartSaver(BView *view, bool preview){
	if (preview){
      doingPreview = true;
   }else{
      doingPreview = false;
   }	
   
   fFrame = view->Frame();
   ReadBitmap(fPath.Path());
   
   if(fBitmap == NULL) {
      MakeBitmap();
   }
   
   srandom(getpid() * time(NULL) | 1);

   return B_OK;
}

/*******************************************************
*   More cleanup stuff when we stop saveing.
*******************************************************/
void Scoot::StopSaver(){
   delete fBitmap;
   fBitmap = NULL;
   delete [] fPoints;
   delete [] fDirections;
   delete [] fMoved;
   delete [] fColors;
}

/*******************************************************
*   This is where are the fun happends. Draw kewl stuff
*   to the screen and just have fun with it.
*******************************************************/
void Scoot::Draw(BView *view, int32 frame){

   if(doingPreview){
     //do some calculations here
     // that should shrink the bitmap down
     // to a size that look about right to 
     // fit on the preview pane
   }

   fFrame = view->Frame();
   fCount = (int)ceil(fFrame.bottom / fHeight);

	for(int32 i = 0; i < fCount; i++) {
		if(fDirections[i] == RIGHT) {
			view->SetHighColor(fColors[i]);
			view->FillRect(BRect(	fPoints[i].x - fMoved[i], 
									fHeight * i, 
									fPoints[i].x, 
									fHeight * (i + 1) - 1	)	);
		}
		else {
			view->SetHighColor(fColors[i]);
			view->FillRect(BRect(	fPoints[i].x + fWidth, 
									fHeight * i, 
									fPoints[i].x + fWidth + fMoved[i], 
									fHeight * (i + 1) - 1	)	);
		}
		 
		//This wa Async but it blured sometimes .. look better this way
		view->DrawBitmap(fBitmap, BPoint(fPoints[i].x, fHeight * i));
		
		if(fPoints[i].x < 0) {
			fDirections[i] = RIGHT;
			fColors[i].red = rand() % 256;
			fColors[i].green = rand() % 256;
			fColors[i].blue = rand() % 256;
		}
		else if(fPoints[i].x + fWidth > fFrame.right) {
			fDirections[i] = LEFT;
			fColors[i].red = rand() % 256;
			fColors[i].green = rand() % 256;
			fColors[i].blue = rand() % 256;
		}
		fMoved[i] = rand() % 50;
		if(fDirections[i] == RIGHT) {
			fPoints[i].x += fMoved[i];
		}else{
			fPoints[i].x -= fMoved[i];
	    }
	 }

}

/*******************************************************
*   Setup the config panel so the user can control us
*******************************************************/
void Scoot::StartConfig(BView *configView){
    BRect bounds = configView->Bounds();
	bounds.InsetBy(5, 0);
	MySSConfigPanel *ConfigPanel = new MySSConfigPanel(bounds, this);
	configView->AddChild(ConfigPanel);
}

/*******************************************************
*   Kill the Config panel. Nothing much
*******************************************************/
void Scoot::StopConfig(){
}

/*******************************************************
*   Compact error handaling method to grab a prity pic
*   and update the fCound and set the new arrays. also
*   init them so we dont get messed up :)
*******************************************************/
void Scoot::ReadBitmap(const char *filename){
   delete fBitmap;
   fBitmap = BTranslationUtils::GetBitmap(filename);
   
   if(fBitmap != NULL) {
      fHeight = fBitmap->Bounds().Height() + 1;
      fWidth = fBitmap->Bounds().Width();
   }else{
      MakeBitmap();
   }
   
   //Added this in here because if we are changeing
   // the bitmap live we need to keep up with all 
   // of this too!
   fCount = (int)ceil(fFrame.bottom / fHeight);

   fPoints = new BPoint[fCount + 1];
   fDirections = new direction[fCount + 1];
   fMoved = new float[fCount + 1];
   fColors = new rgb_color[fCount + 1];
   
   for(int32 i = 0; i < fCount; i++) {
      fPoints[i] = B_ORIGIN;
      fDirections[i] = RIGHT;
      fMoved[i] = 0;
      fColors[i].red = rand() % 256;
      fColors[i].green = rand() % 256;
      fColors[i].blue = rand() % 256;
   }
}

/*******************************************************
*   Smash our current stat into a BMessage so we can 
*   have it next time we startup. You can save off 
*   anythign you want. The more info the better.
*******************************************************/
status_t Scoot::SaveState(BMessage *info) const{
   BString tmp;
   tmp.SetTo(fPath.Path());
   info->AddString("path", tmp.String());
   
   return B_OK;
}

/*******************************************************
*   Grab all the users fav preffs, and set them to be 
*   the curent valuse.
*******************************************************/
void Scoot::restore_state(BMessage *state_msg){
   const char *new_string;
   
   if (state_msg->FindString("path", &new_string) == B_OK){
      fPath.SetTo(new_string);
   }
   
}



